<< problem 219 - Skew-cost coding | Tribonacci non-divisors - problem 225 >> |
Problem 222: Sphere Packing
(see projecteuler.net/problem=222)
What is the length of the shortest pipe, of internal radius 50mm, that can fully contain 21 balls of radii 30mm, 31mm, ..., 50mm?
Give your answer in micrometres (10^{-6} m) rounded to the nearest integer.
My Algorithm
This was a strange problem ... I came up with a solution that was slow and memory hungry.
Then I saw an optimization and it became faster and even used less memory.
But then I saw that I can basically solve it instantly - and wasn't willing the adapt the code accordingly.
My solution isn't based on the fully optimized (I dare to say "trivial") algorithm.
It basically tries to put all balls in various orders into the pipe and measures which combination is the shortest.
The first observation is that the 3D objects (balls, pipe) can be reduced to their 2D equivalents (circles between two lines).
If two balls a and b are stacked on top of each other, then their centres have a distance of d = r_a + r_b.
I assumed that the pipe is vertical. Then a right triangle exists:
the hypotenuse is d = r_a + r_b, one side is x = (50 - r_a) + (50 - r_b) = 100 - (r_a + r_b) and the other side y is:
(1) d^2 = x^2 + y^2
(2) y^2 = d^2 - x^2
(3) y = sqrt{d^2 - x^2}
Substituting d and x:
(4) y = sqrt{(r_a + r_b)^2 - (100 - (r_a + r_b))^2}
→ This formula can be found in the function getDistanceY
.
The function search
enumerated all combinations and returns the correct result using Dynamic Programming.
As mentioned before, my initial approach was working but was slow and memory hungry.
Then it appeared to me that the two largest balls must be at the ends of the pipe (which was verified by search
).
Fixing those two balls shrinks the size of the internal cache
if size
by factor 4 and speeds up the algorithm substantially.
The code below does exactly that.
Alternative Approaches
But then I thought: if I remove the two biggest balls - what happens to the rest ?
Well, the same idea can be applied over and over again: pick the next two largest balls and put them next to the previously largest balls, and so on.
In the end, the balls will be placed like this: 50mm, 48mm, 46mm, 44mm, ..., 43mm, 45mm, 47mm, 49mm.
Generating that sequence can be done in a simple for
-loop and eliminates the need for search
(and its large cache
).
The expecting computation time will be close to zero.
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This is equivalent toecho "10 5 10" | ./222
Output:
Note: the original problem's input 50 30 50
cannot be entered
because just copying results is a soft skill reserved for idiots.
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too. Or just jump to my GitHub repository.
#include <iostream>
#include <vector>
#include <cmath>
unsigned int minRadius = 30;
unsigned int maxRadius = 50;
unsigned int numBalls = maxRadius - minRadius + 1;
unsigned int pipeRadius = 50;
// double has 64 bits => memoized cache would be twice as large
typedef float Number;
// an arbitrarily high number (more than sum of all radii)
const Number WorstCase = 999999999;
// get distance between centre of two balls along the y axis
Number getDistanceY(unsigned int radiusA, unsigned int radiusB)
{
auto sum = radiusA + radiusB;
return sqrt(sum*sum - (2*pipeRadius - sum)*(2*pipeRadius - sum));
}
// mask - bitmask of all available spheres
Number search(unsigned int mask, unsigned int lastRadius)
{
// are all balls in the pipe (except for the largest) ?
if (mask == 0)
return getDistanceY(lastRadius, maxRadius) + maxRadius;
// memoize
const unsigned int Shift = numBalls - 2; // ignore the two largest balls
const Number Invalid = -1;
static std::vector<Number> cache((1 << Shift) * (maxRadius - minRadius + 1), Invalid);
// already computed ?
auto id = mask + ((lastRadius - minRadius) << Shift);
if (cache[id] != Invalid)
return cache[id];
Number best = WorstCase;
for (unsigned int radius = minRadius; radius <= maxRadius; radius++) // could stop at maxRadius - 2, too
{
// already used ?
auto bit = 1 << (radius - minRadius);
if ((mask & bit) == 0)
continue;
// process recursively
auto newHeight = getDistanceY(radius, lastRadius) + search(mask & ~bit, radius);
// improvement ?
if (best > newHeight)
best = newHeight;
}
cache[id] = best;
return best;
}
int main()
{
std::cin >> pipeRadius >> minRadius >> maxRadius;
// avoid invalid input (for live test only)
if (minRadius >= maxRadius)
return 1;
if (pipeRadius < maxRadius)
return 2;
numBalls = maxRadius - minRadius + 1;
// all bits set => all balls still available
unsigned int mask = (1 << (maxRadius - minRadius + 1)) - 1;
// the two largest balls must be at the ends of the pipe, remove those bits
for (unsigned int radius = maxRadius - 1; radius <= maxRadius; radius++)
mask &= ~(1 << (radius - minRadius));
// start with the second largest ball
auto first = maxRadius - 1;
// half of the first ball (from its border to its centre) plus everything else
auto best = first + search(mask, first);
// convert to micrometre and round to nearest integer
std::cout << (unsigned int)round(1000 * best) << std::endl;
return 0;
}
This solution contains 15 empty lines, 16 comments and 3 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in 2.2 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
Peak memory usage was about 45 MByte.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
July 24, 2017 submitted solution
July 24, 2017 added comments
Difficulty
Project Euler ranks this problem at 60% (out of 100%).
Links
projecteuler.net/thread=222 - the best forum on the subject (note: you have to submit the correct solution first)
Code in various languages:
Python github.com/Meng-Gen/ProjectEuler/blob/master/222.py (written by Meng-Gen Tsai)
Python github.com/nayuki/Project-Euler-solutions/blob/master/python/p222.py (written by Nayuki)
Python github.com/smacke/project-euler/blob/master/python/222.py (written by Stephen Macke)
C++ github.com/roosephu/project-euler/blob/master/222.cpp (written by Yuping Luo)
Java github.com/nayuki/Project-Euler-solutions/blob/master/java/p222.java (written by Nayuki)
Java github.com/thrap/project-euler/blob/master/src/Java/Problem222.java (written by Magnus Solheim Thrap)
Go github.com/frrad/project-euler/blob/master/golang/Problem222.go (written by Frederick Robinson)
Mathematica github.com/steve98654/ProjectEuler/blob/master/222.nb
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own.
Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
I stopped working on Project Euler problems around the time they released 617.
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 | 617 | 618 | 619 | 620 | 621 | 622 | 623 | 624 | 625 |
626 | 627 | 628 | 629 | 630 | 631 | 632 | 633 | 634 | 635 | 636 | 637 | 638 | 639 | 640 | 641 | 642 | 643 | 644 | 645 | 646 | 647 | 648 | 649 | 650 |
651 | 652 | 653 | 654 | 655 | 656 | 657 | 658 | 659 | 660 | 661 | 662 | 663 | 664 | 665 | 666 | 667 | 668 | 669 | 670 | 671 | 672 | 673 | 674 | 675 |
676 | 677 | 678 | 679 | 680 | 681 | 682 | 683 | 684 | 685 | 686 | 687 | 688 | 689 | 690 | 691 | 692 | 693 | 694 | 695 | 696 | 697 | 698 | 699 | 700 |
701 | 702 | 703 | 704 | 705 | 706 | 707 | 708 | 709 | 710 | 711 | 712 | 713 | 714 | 715 | 716 | 717 | 718 | 719 | 720 | 721 | 722 | 723 | 724 | 725 |
726 | 727 | 728 | 729 | 730 | 731 | 732 | 733 | 734 | 735 | 736 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 219 - Skew-cost coding | Tribonacci non-divisors - problem 225 >> |